<template>
  <time class="clock">
    <span>{{ hour }}:{{ minute }}</span>
    <span class="clock__meta">
      <span v-if="currentSettings.showSeconds" class="clock__seconds">{{ second }}</span>
      <span v-if="currentSettings.hourFormat === '12'" class="clock__am-pm">{{ dayPeriod }}</span>
    </span>
  </time>
</template>

<script>
module.exports = {
  name: "clock",
  props: {
    currentSettings: {
      Type: Object,
      required: true,
    },
    records: {
      type: Array,
      required: false,
    },
    language: {
      type: String,
      required: true,
    },
    locale: {
      type: String,
      required: true,
    },
    fetchAsset: {
      type: Function,
      required: false,
    },
    backendUrl: {
      type: String,
      required: true,
    },
  },
  data: function () {
    return {
      hour: "",
      minute: "",
      second: "",
      dayPeriod: "",
    };
  },
  computed: {
    timezone: function () {
      return (
          (this.currentSettings.useCustomTimezone && this.currentSettings.customTimezone) ||
          this.$store.state.settings.system_timezone.attributes.value
      );
    },
  },
  methods: {
    time: function () {
      const now = new Date();
      this.formatted = new Intl.DateTimeFormat(this.language, {
        // FIXME: temporary until Ubuntu Core provides consistent timezone info to browser
        timeZone: this.timezone,
        hour12: this.currentSettings.hourFormat === "12",
        hour: "2-digit",
        minute: "2-digit",
        second: "2-digit",
      })
          .formatToParts(now)
          .map(({type, value}) => {
            if (type === "literal") return;
            this[type] = value;
          });
    },
  },
  beforeMount: function () {
    this.time();
    this.$options.interval = setInterval(this.time, 1000);
  },
  beforeDestroy() {
    clearInterval(this.$options.interval);
  },
};
</script>

<style>
.clock {
  display: inline-flex;
  align-items: flex-start;
  line-height: 0.7;
  font-variant-numeric: tabular-nums;
}

.clock__meta {
  display: inline-flex;
  flex-direction: column;
  align-items: flex-start;
  margin-left: 0.25rem;
}

.clock__seconds {
  font-size: 40%;
  line-height: 0.85;
}

.clock__am-pm {
  font-size: 30%;
  line-height: 1.1;
}

.clock__seconds + .clock__am-pm {
  font-size: 20%;
  line-height: 1.4;
}

.font-inter .clock {
  letter-spacing: -0.125rem;
}
</style>
